diff --git a/platform/linux-generic/m4/configure.m4 b/platform/linux-generic/m4/configure.m4
index 589722f..8b09a45 100644
--- a/platform/linux-generic/m4/configure.m4
+++ b/platform/linux-generic/m4/configure.m4
@@ -24,4 +24,5 @@ m4_include([platform/linux-generic/m4/odp_pcap.m4])
 
 AC_CONFIG_FILES([platform/linux-generic/Makefile
 		 platform/linux-generic/test/Makefile
-		 platform/linux-generic/test/pktio/Makefile])
+		 platform/linux-generic/test/validation/Makefile
+		 platform/linux-generic/test/validation/pktio/Makefile])
diff --git a/platform/linux-generic/test/.gitignore b/platform/linux-generic/test/.gitignore
index 5dabf91..7e563b8 100644
--- a/platform/linux-generic/test/.gitignore
+++ b/platform/linux-generic/test/.gitignore
@@ -1,3 +1,2 @@
 *.log
 *.trs
-tests-validation.env
diff --git a/platform/linux-generic/test/Makefile.am b/platform/linux-generic/test/Makefile.am
index 56e3d43..312d18e 100644
--- a/platform/linux-generic/test/Makefile.am
+++ b/platform/linux-generic/test/Makefile.am
@@ -1,62 +1 @@
-include $(top_srcdir)/test/Makefile.inc
-TESTS_ENVIRONMENT += TEST_DIR=${top_builddir}/test/validation
-
-ODP_MODULES = pktio
-
-if test_vald
-TESTS = pktio/pktio_run \
-	pktio/pktio_run_tap \
-	${top_builddir}/test/validation/atomic/atomic_main$(EXEEXT) \
-	${top_builddir}/test/validation/barrier/barrier_main$(EXEEXT) \
-	${top_builddir}/test/validation/buffer/buffer_main$(EXEEXT) \
-	${top_builddir}/test/validation/classification/classification_main$(EXEEXT) \
-	${top_builddir}/test/validation/config/config_main$(EXEEXT) \
-	${top_builddir}/test/validation/cpumask/cpumask_main$(EXEEXT) \
-	${top_builddir}/test/validation/crypto/crypto_main$(EXEEXT) \
-	${top_builddir}/test/validation/errno/errno_main$(EXEEXT) \
-	${top_builddir}/test/validation/hash/hash_main$(EXEEXT) \
-	${top_builddir}/test/validation/init/init_main_ok$(EXEEXT) \
-	${top_builddir}/test/validation/init/init_main_abort$(EXEEXT) \
-	${top_builddir}/test/validation/init/init_main_log$(EXEEXT) \
-	${top_builddir}/test/validation/lock/lock_main$(EXEEXT) \
-	${top_builddir}/test/validation/packet/packet_main$(EXEEXT) \
-	${top_builddir}/test/validation/pool/pool_main$(EXEEXT) \
-	${top_builddir}/test/validation/queue/queue_main$(EXEEXT) \
-	${top_builddir}/test/validation/random/random_main$(EXEEXT) \
-	${top_builddir}/test/validation/scheduler/scheduler_main$(EXEEXT) \
-	${top_builddir}/test/validation/std_clib/std_clib_main$(EXEEXT) \
-	${top_builddir}/test/validation/thread/thread_main$(EXEEXT) \
-	${top_builddir}/test/validation/time/time_main$(EXEEXT) \
-	${top_builddir}/test/validation/timer/timer_main$(EXEEXT) \
-	${top_builddir}/test/validation/traffic_mngr/traffic_mngr_main$(EXEEXT) \
-	${top_builddir}/test/validation/shmem/shmem_main$(EXEEXT) \
-	${top_builddir}/test/validation/system/system_main$(EXEEXT)
-
-SUBDIRS = $(ODP_MODULES)
-
-if HAVE_PCAP
-TESTS += pktio/pktio_run_pcap
-endif
-if netmap_support
-TESTS += pktio/pktio_run_netmap
-endif
-endif
-
-dist_check_SCRIPTS = run-test tests-validation.env $(LOG_COMPILER)
-
-test_SCRIPTS = $(dist_check_SCRIPTS)
-
-tests-validation.env:
-	echo "TESTS=\"$(TESTS)\""    > $@
-	echo "$(TESTS_ENVIRONMENT)" >> $@
-	echo "$(LOG_COMPILER)"      >> $@
-
-if test_installdir
-installcheck-local:
-	$(DESTDIR)/$(testdir)/run-test
-endif
-
-#performance tests refer to pktio_env
-if test_perf
-SUBDIRS = pktio
-endif
+SUBDIRS = validation
diff --git a/platform/linux-generic/test/validation/.gitignore b/platform/linux-generic/test/validation/.gitignore
new file mode 100644
index 0000000..acc4880
--- /dev/null
+++ b/platform/linux-generic/test/validation/.gitignore
@@ -0,0 +1 @@
+tests-validation.env
diff --git a/platform/linux-generic/test/validation/Makefile.am b/platform/linux-generic/test/validation/Makefile.am
new file mode 100644
index 0000000..165a6bd
--- /dev/null
+++ b/platform/linux-generic/test/validation/Makefile.am
@@ -0,0 +1,64 @@
+include $(top_srcdir)/test/Makefile.inc
+TESTS_ENVIRONMENT += TEST_DIR=${top_builddir}/test/validation
+
+ODP_MODULES = pktio
+
+if test_vald
+TESTS = pktio/pktio_run \
+	pktio/pktio_run_tap \
+	${top_builddir}/test/validation/atomic/atomic_main$(EXEEXT) \
+	${top_builddir}/test/validation/barrier/barrier_main$(EXEEXT) \
+	${top_builddir}/test/validation/buffer/buffer_main$(EXEEXT) \
+	${top_builddir}/test/validation/classification/classification_main$(EXEEXT) \
+	${top_builddir}/test/validation/config/config_main$(EXEEXT) \
+	${top_builddir}/test/validation/cpumask/cpumask_main$(EXEEXT) \
+	${top_builddir}/test/validation/crypto/crypto_main$(EXEEXT) \
+	${top_builddir}/test/validation/errno/errno_main$(EXEEXT) \
+	${top_builddir}/test/validation/hash/hash_main$(EXEEXT) \
+	${top_builddir}/test/validation/init/init_main_ok$(EXEEXT) \
+	${top_builddir}/test/validation/init/init_main_abort$(EXEEXT) \
+	${top_builddir}/test/validation/init/init_main_log$(EXEEXT) \
+	${top_builddir}/test/validation/lock/lock_main$(EXEEXT) \
+	${top_builddir}/test/validation/packet/packet_main$(EXEEXT) \
+	${top_builddir}/test/validation/pool/pool_main$(EXEEXT) \
+	${top_builddir}/test/validation/queue/queue_main$(EXEEXT) \
+	${top_builddir}/test/validation/random/random_main$(EXEEXT) \
+	${top_builddir}/test/validation/scheduler/scheduler_main$(EXEEXT) \
+	${top_builddir}/test/validation/std_clib/std_clib_main$(EXEEXT) \
+	${top_builddir}/test/validation/thread/thread_main$(EXEEXT) \
+	${top_builddir}/test/validation/time/time_main$(EXEEXT) \
+	${top_builddir}/test/validation/timer/timer_main$(EXEEXT) \
+	${top_builddir}/test/validation/traffic_mngr/traffic_mngr_main$(EXEEXT) \
+	${top_builddir}/test/validation/shmem/shmem_main$(EXEEXT) \
+	${top_builddir}/test/validation/system/system_main$(EXEEXT)
+
+SUBDIRS = $(ODP_MODULES)
+
+if HAVE_PCAP
+TESTS += pktio/pktio_run_pcap
+endif
+endif
+
+dist_check_SCRIPTS = ../run-test tests-validation.env $(LOG_COMPILER)
+
+test_SCRIPTS = $(dist_check_SCRIPTS)
+
+.PHONY: tests-validation.env
+tests-validation.env:
+	@echo "TESTS=\"$(TESTS)\""    > $@
+	@echo "$(TESTS_ENVIRONMENT)" >> $@
+	@echo "LOG_COMPILER=\"$(LOG_COMPILER)\""      >> $@
+
+if test_installdir
+installcheck-local:
+		echo "trying $(DESTDIR)/$(testdir)/run-test"
+		$(DESTDIR)/$(testdir)/run-test
+endif
+
+clean-local:
+	rm -rf $(builddir)/tests-validation.env
+
+#performance tests refer to pktio_env
+if test_perf
+SUBDIRS = pktio
+endif
diff --git a/platform/linux-generic/test/pktio/.gitignore b/platform/linux-generic/test/validation/pktio/.gitignore
similarity index 100%
rename from platform/linux-generic/test/pktio/.gitignore
rename to platform/linux-generic/test/validation/pktio/.gitignore
diff --git a/platform/linux-generic/test/pktio/Makefile.am b/platform/linux-generic/test/validation/pktio/Makefile.am
similarity index 100%
rename from platform/linux-generic/test/pktio/Makefile.am
rename to platform/linux-generic/test/validation/pktio/Makefile.am
diff --git a/platform/linux-generic/test/pktio/pktio_env b/platform/linux-generic/test/validation/pktio/pktio_env
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_env
rename to platform/linux-generic/test/validation/pktio/pktio_env
diff --git a/platform/linux-generic/test/pktio/pktio_run b/platform/linux-generic/test/validation/pktio/pktio_run
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_run
rename to platform/linux-generic/test/validation/pktio/pktio_run
diff --git a/platform/linux-generic/test/pktio/pktio_run_netmap b/platform/linux-generic/test/validation/pktio/pktio_run_netmap
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_run_netmap
rename to platform/linux-generic/test/validation/pktio/pktio_run_netmap
diff --git a/platform/linux-generic/test/pktio/pktio_run_pcap b/platform/linux-generic/test/validation/pktio/pktio_run_pcap
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_run_pcap
rename to platform/linux-generic/test/validation/pktio/pktio_run_pcap
diff --git a/platform/linux-generic/test/pktio/pktio_run_tap b/platform/linux-generic/test/validation/pktio/pktio_run_tap
similarity index 100%
rename from platform/linux-generic/test/pktio/pktio_run_tap
rename to platform/linux-generic/test/validation/pktio/pktio_run_tap
diff --git a/test/performance/odp_l2fwd_run b/test/performance/odp_l2fwd_run
index cab97a8..8dfb415 100755
--- a/test/performance/odp_l2fwd_run
+++ b/test/performance/odp_l2fwd_run
@@ -37,11 +37,11 @@ elif  [ "$ODP_PLATFORM" = "" ]; then
 	echo "$0: error: ODP_PLATFORM must be defined"
 	# not skipped as this should never happen via "make check"
 	exit 1
-elif [ -f ${TEST_SRC_DIR}/../../platform/$ODP_PLATFORM/test/pktio/pktio_env ]; then
-	. ${TEST_SRC_DIR}/../../platform/$ODP_PLATFORM/test/pktio/pktio_env
+elif [ -f ${TEST_SRC_DIR}/../../platform/$ODP_PLATFORM/test/validation/pktio/pktio_env ]; then
+	. ${TEST_SRC_DIR}/../../platform/$ODP_PLATFORM/test/validation/pktio/pktio_env
 else
 	echo "BUG: unable to find pktio_env!"
-	echo "pktio_env has to be in current directory or in platform/\$ODP_PLATFORM/test."
+	echo "pktio_env has to be in current directory or in platform/\$ODP_PLATFORM/validation/test."
 	echo "ODP_PLATFORM=\"$ODP_PLATFORM\""
 	exit 1
 fi